/**
 * 
 */
package ch.ethz.se.rpnc.node.visitor;

import ch.ethz.se.rpnc.node.DivideByOperator;
import ch.ethz.se.rpnc.node.MinusOperator;
import ch.ethz.se.rpnc.node.Operand;
import ch.ethz.se.rpnc.node.PlusOperator;
import ch.ethz.se.rpnc.node.TimesOperator;

/**
 * Visitor for nodes (Visitor pattern).
 * @author aleitner
 */
public interface Visitor
{
	/**
	 * Visit operand.
	 * @param o Operand to visit.
	 */
	public void visitOperand(Operand o);

	/**
	 * Visit plus-operator.
	 * @param o Operator to visit. 
	 * @throws Exception 
	 */
	public void visitPlusOperator(PlusOperator o) throws Exception;

	/**
	 * Visit minus-operator.
	 * @param o Operand to visit.
	 * @throws Exception 
	 */
	public void visitMinusOperator(MinusOperator o) throws Exception;
	
	/**
	 * Visit times-operator.
	 * @param o Operand to visit.
	 * @throws Exception 
	 */
	public void visitTimesOperator(TimesOperator o) throws Exception;
	
	/**
	 * Visit DivideBy-operator.
	 * @param o Operand to visit.
	 * @throws Exception
	 */
	public void visitDivideByOperator(DivideByOperator o) throws Exception;
}
